using System;

namespace Zadatak3
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int h = int.Parse(s[0]), n = int.Parse(s[1]);
            int[] trenutni = new int[n];
            int[] sledeci = new int[n];
            int[,] matrica = new int[h, n];
            for (int i = 0; i < h; i++)
            {
                s = Console.ReadLine().Split();
                for (int j = 0; j < n; j++)
                {
                    matrica[i, j] =int.Parse(s[j]);
                }
            }
            for (int i = 0; i < h; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (i != 0)
                    {
                        trenutni[j] = sledeci[j];
                    }
                    else
                    {
                        trenutni[j] = 1; 
                    }
                    sledeci[j] = 0;
                    if (trenutni[j] != 0 && matrica[i, j] != 0)
                    {
                        sledeci[j] += trenutni[j];
                    }
                    else if (trenutni[j] != 0 && matrica[i, j] == 0 && j == 0) 
                    {
                        sledeci[j + 1] += trenutni[j];
                    }
                    else if (trenutni[j] != 0 && matrica[i, j] == 0 && j == n-1)
                    {
                        sledeci[j - 1] += trenutni[j];
                    }
                    else if (trenutni[j] != 0 && matrica[i, j] == 0)
                    {
                        sledeci[j - 1] += trenutni[j] / 2;
                        sledeci[j + 1] += trenutni[j] / 2;
                        if (j%2==1)
                        {
                            sledeci[j - 1] += trenutni[j] % 2;
                        }
                        else
                        {
                            sledeci[j + 1] += trenutni[j] % 2;
                        }
                    }
                }
            }
            for (int ispis = 0; ispis < n; ispis++)
            {
                Console.Write(sledeci[ispis] + " ");
            }
        }
    }
}